/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2017/18      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : lecture 3
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: race conditions
///
////////////////////////////////////////////////////////////////////////////////////////////////////

// includes, system
#include <iostream>
#include <iomanip>
#include <vector>
#include <thread>
#include <cstdlib>
#include <cmath>

std::mutex mutex_sum;

////////////////////////////////////////////////////////////////////////////////////////////////////
// Parallel worker for norm computation
////////////////////////////////////////////////////////////////////////////////////////////////////
template< typename T >
void
computeNormWorker( unsigned int tid, unsigned int num_threads, const T* a, int n, T& sum) {

  unsigned int delta = n / num_threads;
  unsigned int i1 = tid * delta;
  unsigned int i2 = (tid+1) * delta;

  T sum_loc = 0;
  for( unsigned int i = i1; i < i2; ++i) {
    sum_loc += a[i] * a[i];
  }

  mutex_sum.lock();
  sum += sum_loc;
  mutex_sum.unlock();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Compute norm of vector
////////////////////////////////////////////////////////////////////////////////////////////////////
template< typename T >
T
computeNorm( unsigned int num_threads, const T* a, const unsigned int n) {

  T sum = 0.0;

  // TODO

  return std::sqrt( sum);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  const unsigned int n = 8192;
  std::cout << "n = " << n << std::endl;
  typedef float DataType;

  // initialize array
  float* a = nullptr;
  // TODO

  // compute norm
  DataType norm1 = computeNorm( 1, a, n);

  std::cerr << std::scientific << std::setprecision( std::numeric_limits<DataType>::digits10 );
  std::cerr << "norm(a) = " << norm1 << std::endl;

  // cleanup

  return EXIT_SUCCESS;
}
